unit ExpValid;

{$IFNDEF DPMI}
   This unit requires DPMI target...
{$ENDIF}

interface

uses
  Objects, MsgBox;

const
  cmIsValidable		= 2072;
  cmGetValidator	= 2073;
  cmSetValidator	= 2074;

type
  PValidData = ^TValidData;
  TValidData = record
    Size: Word;
    Id: String[30];
    TypeId: String[30];
    Description: String[50];
    ObjType: Word;
    PrefixStr: String[30];
  end;

  PExtValidator = ^TExtValidator;
  TExtValidator = record
    VMTLink: Word;
    Status: Word;
    Options: Word;
  end;

  PValidator = ^TValidator;
  TValidator = Object(TObject)
    RemoteSelf: PExtValidator;
    constructor Init(ARemoteSelf: PExtValidator);
    constructor Load(ARemoteSelf: PExtValidator; var S: TStream);
    destructor Done; virtual;
    procedure Store(var S: TStream); virtual;
    function IsValid(const S: String): Boolean; virtual;
    function IsValidInput(var S: string; SuppressFill: Boolean): Boolean; virtual;
    function Valid(const S: string): Boolean; virtual;
    procedure Error; virtual;
  end;

procedure ValidDone(Self: PValidator); export;
procedure ValidStore(Self: PValidator; MemBlock: Pointer; var MaxLen: Word); export;
function ValidIsValid(Self: PValidator; const S: String): Boolean; export;
function ValidIsValidInput(Self: PValidator; var S: String; SuppressFill: Boolean): Boolean; export;
function ValidValid(Self: PValidator; const S: String): Boolean; export;

implementation

uses
  TinyStrm;

constructor TValidator.Init(ARemoteSelf: PExtValidator);
begin
  inherited Init;
  RemoteSelf := ARemoteSelf;
end;

destructor TValidator.Done;
begin
end;

constructor TValidator.Load(ARemoteSelf: PExtValidator; var S: TStream);
begin
  inherited Init;
  RemoteSelf := ARemoteSelf;
end;

procedure TValidator.Store(var S: TStream);
begin
end;

function TValidator.IsValid(const S: String): Boolean;
begin
  IsValid := True;
end;

function TValidator.IsValidInput(var S: string; SuppressFill: Boolean): Boolean;
begin
  IsValidInput := True;
end;

function TValidator.Valid(const S: string): Boolean;
begin
  if IsValid(S) then
    Valid := True
   else begin
    Error;
    Valid := False;
  end;
end;

procedure TValidator.Error;
begin
end;

{ Exported procedures }

procedure ValidDone(Self: PValidator);
begin
  Self^.Done;
end;

procedure ValidStore(Self: PValidator; MemBlock: Pointer; var MaxLen: Word);
var
  S: PStream;
begin
  S := New(PTinyStream, Init(MemBlock, MaxLen));
  Self^.Store(S^);
  MaxLen := S^.GetPos;
  Dispose(S, Done);
end;

function ValidIsValid(Self: PValidator; const S: String): Boolean;
begin
  ValidIsValid := Self^.IsValid(S);
end;

function ValidIsValidInput(Self: PValidator; var S: String; SuppressFill: Boolean): Boolean;
begin
  ValidIsValidInput := Self^.IsValidInput(S, SuppressFill);
end;

function ValidValid(Self: PValidator; const S: String): Boolean;
begin
  ValidValid := Self^.Valid(S);
end;

end.
